/**
 *Messy project idea number ONE.
 *Jenny Chang Computer
 *
 */

import processing.video.*;

Capture video;

PFont fontA;
PFont fontB;
ParticleSystem ps;
int frameNum = 30;
int rectX, rectY;
int rectTimer = 0;
int Mittens = 70;
int touched;
int rectSize = 100;

int brightestX = 0; // X-coordinate of the brightest video pixel
int brightestY = 0; // Y-coordinate of the brightest video pixel

color rectColor=(255);
boolean rectOver = false;

void setup() {
  size(640, 480);
  video=new Capture(this,width,height,30);

  frameRate(30);
  //colorMode(RGB, 255, 255, 255, 255);
  fontA = createFont("Palatino Linotype Negreta cursiva", 60);
  fontB = createFont("Palatino Linotype Negreta cursiva", 60);
  textFont(fontA);
  textFont(fontB);
  rectColor = color(0,0,255,50);
  //baseColor = color(102);
  ps = new ParticleSystem(1, new PVector(width/2,height/2,0));
  noStroke();
  smooth();

  rectX = width/2-rectSize-10;
  rectY = height/2-rectSize/2;
}

void draw() {
  if (video.available()) {
    video.read();
    image(video, 0, 0, width, height); // Draw the webcam video onto the screen

    float brightestValue = 0; // Brightness of the brightest video pixel
    // Search for the brightest pixel: For each row of pixels in the video image and
    // for each pixel in the yth row, compute each pixel's index in the video
    video.loadPixels();
    int index = 0;
    for (int y = 0; y < video.height; y++) {
      for (int x = 0; x < video.width; x++) {
        // Get the color stored in the pixel
        int pixelValue = video.pixels[index];
        // Determine the brightness of the pixel
        float pixelBrightness = brightness(pixelValue);
        // If that value is brighter than any previous, then store the
        // brightness of that pixel, as well as its (x,y) location
        if (pixelBrightness > brightestValue) {
          brightestValue = pixelBrightness;
          brightestY = y;
          brightestX = x;
        }
        index++;
      }
    }
    // Draw a large, yellow circle at the brightest pixel
    fill(255, 204, 0, 128);
    ellipse(brightestX, brightestY, 50, 50);


    textAlign(CENTER, BASELINE);
    update(brightestX, brightestY);

    stroke(255);
    fill(rectColor);
    rect(rectX, rectY, rectSize, rectSize);
    stroke(0);
    ps.run();
    ps.addParticle(brightestX,brightestY);


    //  if((mouseX>320)&&(mouseY>240)&&(frameCount%4>2)){
    //    noStroke();
    //    fill(255, 0, 0, 64);
    //    rect(320, 240, 320, 240);
    //  }

    saveScreenshots();
    //sayCheese();
  }
}

//void sayCheese(){
//  if(touched==7){
//    textFont(fontB);
//  text("SAY CHEESE!",width/2, height/2);
//  
//  touched=0;
//  }
//}

void saveScreenshots(){
  if(touched==7){
    textFont(fontB);
    text("SAY CHEESE!",width/2, height/2);
    saveFrame("saved/frame-####.tga");
    delay(100);
    touched=0;
  }
}

void update(int x, int y){
  //if(overRect(rectX, rectY, rectSize, rectSize)){
  rectTimer++;
  // check the timer  
  //sayCheese();
  if (rectTimer > Mittens) {
    // move the rectangle

    rectX = round(random(0,width-rectSize));
    rectY = round(random(0,height-rectSize));
    println(rectTimer);
    println(Mittens);
    rectTimer=0;
  }

  //  }

  if ( overRect(rectX, rectY, rectSize, rectSize) ) {
    rectOver = true;
    touched++;
    Mittens-=10;
    if(Mittens<=0) {
      Mittens = 70;
    }

    rectX=round(random(0,width-rectSize));
    rectY=round(random(0,height-rectSize));
    // println(touched);
    rectTimer=0;
  }
  else{
    rectOver = false;
  }

  text(Integer.toString(touched),width-100, height-100);
}

boolean overRect(int x, int y, int width, int height){
  if (brightestX >= x && brightestX <= x+width &&
    brightestY >= y && brightestY <= y+height) {
    return true;
  } 
  else {
    return false;
  }
}









